/* 
 * Definicions 
 */
#define TAM_BUF	1024
#define TRUE	1
#define FALSE	0
#define STDIN	0
#define STDOUT	1
#define STDERR	2

#define HEAD1	"<?xml version=\"1.0\" encoding=\"ISO-8859-7\"?>\n"
#define HEAD2   "<rdf:RDF xml:lang=\"en\" xmlns:rdf=\"http:\/\/www.w3.org/1999/02/22-rdf-syntax-ns#\" xmlns:rdfs=\"http:\/\/www.w3.org/2000/01/rdf-schema#\" xmlns:crm=\"http:\/\/cidoc.ics.forth.gr/docs/xml_to_rdfs/CIDOC_v3.3.2.rdfs#\">\n\n"


/* 
 * Includes 
 */
#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <io.h>
#include <stddef.h>


/*
 * Typedefs
 */
//typedef struct NodePila;
typedef struct{
	char nomEnt[TAM_BUF];
    struct NodePila *anterior;
    }NodePila;
typedef struct{
	NodePila *top;
    int numElems;
    }Pila;


/*
 * Prototypes
 */
/*
 * Auxiliar Functions
 */

/* error: Writes an error message and returns to shell.
          If sistema=True, shows the system message
 */
void error(char *miss, int sistema);

/* saltaBlancs: It is used to ignore wite spaces, tabs and carry returns */
char saltaBlancs();

/* trobarPunt: Finds the position inside an entity name, where the piont
               must be. It is after the entity number
 */
int trobarPunt(char nomEnt[]);

/*
 * Stack Functions
 */
/* inicialitzarPila: Inicializes the stack with a NULL pointer and
   					 puts to 0 the number of elements in the stack
 */
void inicialitzarPila();

/* afegirPila: Adds a new entity name to the stack, incrementing the counter */
void afegirPila(char nom[]);

/* buidarPila: Pops an element from the stack, decreasing the counter */
void buidarPila();

/*
 * Program Functions
 */
/* llegirTag: Reads a Tag from the Input File
              Assumes that the file pointer is in the beggining
              of a tag ('<') or in the spaces before it.
 */
void llegirTag(char tag[]);

/* llegirEntitat: Reads the Entity name from the Input file and returns
                  the string to be writen in the Output file.
                  It assumes that the file pointer is after the tag
                  '<in_class>'
 */
char *llegirEntitat(char string[]);

/* llegirNomProp: It reads the information of a property and writes it
                  in the rdf-crm format.
                  It assumes that we have read a tag diferent from
                  '<in_class>'
 */
char *llegirNomProp(char tag[], char string[]);

/* llegirString: Reads characters from the input file until it reaches
                 the character '<'
 */
void llegirString(char string[]);

/* escriureRes: Writes a string to the Output File */
void escriureRes(char string[]);
